## digikam-gmic-qt-3.6.0.20251021-01a0b2c794b4477971498b2c2ce2ef261d5c9646.tar.gz

=== gmicqt/gmic/src/Makefile ===
#
#  File        : Makefile
#                ( Makefile for GNU 'make' utility )
#
#  Description : This Makefile exposes the following entries:
#
#                 . 'all':
#                   Equivalent to 'lib','cli','gimp','gmic_qt','libc','zart' (see below).
#
#                 . 'lib':
#                   C++ API for the G'MIC library. Generate files 'src/libgmic.*'.
#
#                 . 'libc' and 'libc_static':
#                   C API for the G'MIC library. Generate files 'src/libcgmic.*'.
#                   'libc_static' tries to embed most libraries as static.
#
#                 . 'cli', 'cli_shared' and 'cli_static':
#                    G'MIC command line tool. Generate file 'src/gmic[.exe]'
#                    'cli_shared' generates an executable that is dynamically linked with 'libgmic'.
#                    'cli_static' generates an executable where most libraries are statically linked.
#
#                 . 'gimp' and 'gimp_shared':
#                   G'MIC-Qt plug-in for GIMP. Generate file 'gmic-qt/gmic_gimp_qt'.
#                   'gimp_shared' generates a binary that is dynamically linked with 'libgmic'.
#
#                 . 'gmic_qt' and 'gmic_qt_shared':
#                   G'MIC-Qt stand-alone application. Generate file 'gmic-qt/gmic_qt'.
#                   'gimp_shared' generates a binary that is dynamically linked with 'libgmic'.
#
#                 . 'zart':
#                   ZArt interface for real-time processing of videos coming from webcams or files.
#                   Generate file 'zart/zart'.
#
#                ( https://gmic.eu )
#
#  Copyright   : David Tschumperlé
#                ( https://tschumperle.users.greyc.fr/ )
#
#  Licenses    : This file is 'dual-licensed', you have to choose one
#      	          of the two licenses below to apply.
#
#                CeCILL-C
#                The CeCILL-C license is close to the GNU LGPL.
#                ( http://cecill.info/licences/Licence_CeCILL-C_V1-en.html )
#
#            or  CeCILL v2.1
#                The CeCILL license is compatible with the GNU GPL.
#                ( http://cecill.info/licences/Licence_CeCILL_V2.1-en.html )
#
#  This software is governed either by the CeCILL or the CeCILL-C license
#  under French law and abiding by the rules of distribution of free software.
#  You can  use, modify and or redistribute the software under the terms of
#  the CeCILL or CeCILL-C licenses as circulated by CEA, CNRS and INRIA
#  at the following URL: "http://cecill.info".
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  In this respect, the user's attention is drawn to the risks associated
#  with loading,  using,  modifying and/or developing or reproducing the
#  software by the user in light of its specific status of free software,
#  that may mean  that it is complicated to manipulate,  and  that  also
#  therefore means  that it is reserved for developers  and  experienced
#  professionals having in-depth computer knowledge. Users are therefore
#  encouraged to load and test the software's suitability as regards their
#  requirements in conditions enabling the security of their systems and/or
#  data to be ensured and,  more generally, to use and operate it in the
#  same conditions as regards security.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL and CeCILL-C licenses and that you accept its terms.
#

#---------------------------
# Set OS-specific variables
#---------------------------

# Try to auto-detect target OS.
OS = $(shell uname)
PREFIX ?= /usr
LIB ?= lib
BIN ?= bin
INCLUDE ?= include
PIC = -fPIC
EXE =
WGET = wget --no-check-certificate --quiet -O
GIMPTOOL = $(shell command -v gimptool-3.0 >/dev/null 2>&1 && echo gimptool-3.0 || echo gimptool-2.0)
PLUGIN = $(shell $(GIMPTOOL) --gimpplugindir)/plug-ins
SHARE = $(PREFIX)/share
BASH_COMPLETIONSDIR = $(shell pkg-config --variable completionsdir bash-completion || echo $(SHARE)/bash-completion/completions)
VERSION = $(shell grep -F 'gmic_version ' gmic.h | tail -c4 | head -c3)
VERSION1 = $(shell grep -F 'gmic_version ' gmic.h | tail -c4 | head -c1)
VERSION2 = $(shell grep -F 'gmic_version ' gmic.h | tail -c3 | head -c1)
VERSION3 = $(shell grep -F 'gmic_version ' gmic.h | tail -c2 | head -c1)
SVERSION=$(VERSION1).$(VERSION2).$(VERSION3)
SRC_PATH=$(shell pwd)

# Check that versions of files 'CImg.h' and 'gmic.h' match.
ifneq (,$(wildcard CImg.h))
CIMG_VERSION = $(shell grep -F 'cimg_version ' CImg.h | tail -c4 | head -c3)
else
CIMG_VERSION = $(VERSION)
endif

ifneq ($(VERSION),$(CIMG_VERSION))
REMOVE_CIMG_H := $(shell rm -f CImg.h)
endif

ifeq ($(OS),Linux)
OS = Unix
endif

ifeq ($(OS),GNU/kFreeBSD)
OS = Unix
endif

ifeq ($(OS),GNU)
OS = Unix
endif

ifeq ($(OS),FreeBSD)
OS = Unix
PREFIX = /usr/local
endif

ifeq ($(OS),DragonFly)
OS = Unix
PREFIX = /usr/local
endif

ifeq ($(OS),NetBSD)
OS = Unix
endif

ifneq (,$(findstring MINGW,$(OS)))
OS = Windows
PREFIX = /mingw64
endif

ifeq ($(OS),Darwin)
ifeq (,$(wildcard /opt/local))
PREFIX = /usr/local
PLUGIN = $(HOME)/Library/Application\ Support/Gimp/plug-ins
else
PREFIX = /opt/local
endif
WGET = curl -k -L --silent -o
endif

ifeq ($(OS),Windows)
EXE = .exe
PIC =
endif

ifneq (,$(findstring g++,$(CXX)))
IS_GCC = 1
endif
ifneq (,$(findstring clang++,$(CXX)))
IS_CLANG = 1
endif
ifneq (,$(findstring icpc,$(CXX)))
IS_ICPC = 1
endif

ifdef NOSTRIP
STRIP = echo skip strip
else
STRIP = strip
endif

ifndef QMAKE
QMAKE = qmake
endif

#--------------------------------------------------------
# Define compilation flags to se for each enable feature
#--------------------------------------------------------

# Flags set to describe a 'prerelease' version.
PRERELEASE = $(shell date +%y%m%d%H)
PRERELEASE_CFLAGS = -Dgmic_prerelease="\\\"$(PRERELEASE)\\\""

# Minimal set of flags mandatory to compile G'MIC.
MANDATORY_CFLAGS = -Dcimg_date=\\\"\\\" -Dcimg_time=\\\"\\\" -Dcimg_use_zlib -I. $(shell pkg-config --cflags zlib || echo -I$(PREFIX)/$(INCLUDE)) $(PRERELEASE_CFLAGS) $(EXTRA_CFLAGS)
MANDATORY_LIBS = $(shell pkg-config --libs zlib || echo -lz) $(EXTRA_LIBS)

ifndef NO_SRIPDLIB
MANDATORY_CFLAGS += -std=c++11 -pedantic
endif
MANDATORY_LIBS += -L. -L$(PREFIX)/$(LIB) -Wl,-rpath,.
ifdef IS_GCC
MANDATORY_CFLAGS += -Wall -Wextra -Wfatal-errors -Werror=unknown-pragmas -Werror=unused-label
GCC_VER_GTEQ5 = $(shell expr `$(CXX) -dumpversion | cut -f1 -d.` \>= 5)
ifeq ($(GCC_VER_GTEQ5),1)
MANDATORY_CFLAGS += -Wshadow
endif
endif
ifeq ($(OS),Unix)
MANDATORY_CFLAGS += -Dcimg_use_vt100
endif
ifeq ($(OS),Darwin)
ifndef NO_STDLIB
MANDATORY_CFLAGS += -stdlib=libc++
endif
endif
ifeq ($(OS),Windows)
MANDATORY_LIBS += -Wl,--stack,16777216
endif

# Enable optimizations for 'cli'.
FLTO = -flto
ifdef IS_GCC
OPT_CFLAGS = -O3 -mtune=generic # '-Ofast' makes things unstable
OPT_LIBS = # ${FLTO}
endif
ifdef IS_CLANG
OPT_CFLAGS = -O3 -mtune=generic --stdlib=libc++ # '-Ofast' makes things unstable
OPT_LIBS = ${FLTO}
endif
ifdef icpc
OPT_CFLAGS = -fast
OPT_LIBS =
endif

# Enable multi-threading support.
PARALLEL_CFLAGS = -Dgmic_is_parallel
ifneq ($(OS),Windows)
PARALLEL_LIBS = -lpthread
endif

# Enable parallelization, using OpenMP.
# (http://www.openmp.org/)
ifdef IS_CLANG
OPENMP_CFLAGS = -I/usr/lib/gcc/x86_64-linux-gnu/9/include -Dcimg_use_openmp -fopenmp=libomp
OPENMP_LIBS = -lomp
else
OPENMP_CFLAGS = -fopenmp -Dcimg_use_openmp
OPENMP_LIBS = -lgomp
endif

# Enable software debugging.
# (Use address sanitizer and thus slows down the code)
ifeq ($(OS),Windows)
DEBUG_CFLAGS = -pedantic -Dcimg_verbosity=3 -Dcimg_strict_warnings -g
else
DEBUG_CFLAGS = -pedantic -Dcimg_verbosity=3 -Dcimg_strict_warnings -g -fsanitize=address # -fsanitize=thread # -fsanitize=undefined # Removed '-ansi' as it (silently) disables c++11.
endif

# Enable extra checking of image buffer pointers.
# (Useful for debug, also slows down the code)
ifneq ($(OS),Darwin)
CHECKIMAGE_CFLAGS = # -Dgmic_check_image
endif

# Enable cancellation points in CImg methods.
ABORT_CFLAGS = -Dcimg_use_abort

# Enable image display, using X11 (Unix).
# (Keep /usr/ dirname here since X11 is located in /usr/ on Mac too)
ifneq ($(OS),Darwin)
X11_CFLAGS = -Dcimg_display=1 $(shell pkg-config --cflags x11 || echo -I/usr/X11R6/include) #-Dcimg_use_xrandr
X11_LIBS = $(shell pkg-config --libs x11 || echo -L/usr/X11R6/lib -lX11) -lpthread # $(shell pkg-config --libs xrandr || echo -lXrandr)
else
ifeq (,$(wildcard /usr/X11))
X11_CFLAGS = -Dcimg_display=0 #-Dcimg_use_xrandr
X11_LIBS = -lpthread # $(shell pkg-config --libs xrandr || echo -lXrandr)
else
X11_CFLAGS = -Dcimg_display=1 $(shell pkg-config --cflags x11 || echo -I/usr/X11/include) #-Dcimg_use_xrandr
X11_LIBS = -L/usr/X11/lib -lX11 -lpthread # $(shell pkg-config --libs xrandr || echo -lXrandr)
endif
endif

# Enable faster X11 display, using XShm extension.
# (ftp://www.x.org/pub/X11R7.7/doc/man/man3/XShm.3.xhtml)
XSHM_CFLAGS = -Dcimg_use_xshm $(shell pkg-config --cflags xcb-shm)
XSHM_LIBS = $(shell pkg-config --libs xcb-shm || echo -L$(PREFIX)/X11R6/lib) -lXext

# Enable image display, using SDL (All platforms).
SDL3_CFLAGS = -Dcimg_display=3 $(shell pkg-config --cflags sdl3 || echo -I/usr/local/include)
SDL3_LIBS = $(shell pkg-config --libs sdl3 || echo -L/usr/local/lib -lSDL3 -Wl,-rpath,/usr/local/lib)

# Enable image display, using GDI32 (Windows).
GDI32_CFLAGS = -Dcimg_display=2
GDI32_LIBS = -lgdi32

# Enable native support of PNG image files, using the PNG library.
# (http://www.libpng.org/pub/png/libpng.html)
ifneq ($(OS),Darwin)
PNG_CFLAGS = -Dcimg_use_png $(shell pkg-config --cflags libpng)
PNG_LIBS = $(shell pkg-config --libs libpng || echo -lpng -lz)
else
ifeq (,$(wildcard /tmp/skl))
PNG_CFLAGS = -Dcimg_use_png $(shell pkg-config --cflags libpng)
PNG_LIBS = $(shell pkg-config --libs libpng || echo -lpng -lz)
else
PNG_CFLAGS = -Dcimg_use_png
PNG_LIBS = -lpng -lz
endif
endif

# Enable native support of JPEG image files, using the JPEG library.
# (http://libjpeg.sourceforge.net/)
JPEG_CFLAGS = -Dcimg_use_jpeg $(shell pkg-config --cflags libjpeg)
JPEG_LIBS = $(shell pkg-config --libs libjpeg || echo -ljpeg)

# Enable native support of JPEG XL image files, using the JXL library.
# (https://en.wikipedia.org/wiki/JPEG_XL)
JXL_CFLAGS = -Dcimg_use_jxl $(shell pkg-config --cflags libjxl)
JXL_LIBS = $(shell pkg-config --libs libjxl || echo -ljxl)

# Enable native support of TIFF image files, using the TIFF library.
# (http://www.libtiff.org/)
TIFF_CFLAGS = -Dcimg_use_tiff $(shell pkg-config --cflags libtiff-4)
TIFF_LIBS = $(shell pkg-config --libs libtiff-4 || echo -ltiff)

# Enable native support for loading HEIC/AVIF image files, using the libheif library.
# ( https://github.com/strukturag/libheif )
HEIF_CFLAGS = -Dcimg_use_heif
HEIF_LIBS = -lheif

# Enable native support of MINC2 image files, using the MINC2 library.
# ( http://en.wikibooks.org/wiki/MINC/Reference/MINC2.0_Users_Guide )
MINC2_CFLAGS = -Dcimg_use_minc2 -I${HOME}/local/include
MINC2_LIBS = -lminc_io -lvolume_io2 -lminc2 -lnetcdf -lhdf5 -lz -L${HOME}/local/lib

# Enable native support for downloading files from the network.
# ( http://curl.haxx.se/libcurl/ )
CURL_CFLAGS = -Dcimg_use_curl $(shell pkg-config --cflags libcurl)
CURL_LIBS = $(shell pkg-config --libs libcurl || echo -lcurl)

# Enable native support of webcams and video streaming, using the OpenCV library.
# (https://opencv.org/)
OPENCV_CFLAGS = -Dcimg_use_opencv $(shell pkg-config opencv --cflags) -I/usr/include/opencv -I/usr/include/opencv4
OPENCV_LIBS = $(shell pkg-config opencv --libs || echo -lopencv_core -lopencv_highgui -lopencv_videoio)

# Enable support of most classical image file formats, using the GraphicsMagick++ library.

=== gmicqt/gmic/resources/debian/control ===
Source: gmic
Section: graphics
Priority: optional
Maintainer: Bernd Zeimetz <bzed@debian.org>
Build-Depends: debhelper (>= 7.0.50),
 libgimp2.0-dev | libgimp3.0-dev,
 libx11-dev, libxrandr-dev, libfftw3-dev | fftw3-dev,
 libcurl3 | libcurl4,
 libopenexr-dev, libqt4-core | qt5-default, libwebp-dev
Standards-Version: 3.9.2
Homepage: https://gmic.eu/
Vcs-Git: git://git.debian.org/collab-maint/gmic.git
Vcs-Browser: https://git.debian.org/?p=collab-maint/gmic.git

Package: gmic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GREYC's Magic for Image Computing
 G'MIC is a full-featured open-source framework for image processing.
 It provides several different user interfaces to convert/manipulate/filter/visualize
 generic image datasets, ranging from 1D scalar signals to 3D+t sequences of
 multi-spectral volumetric images, including 2D color images.
 .
 This package contains the command-line tool (gmic), the plug-in for gimp (gmic_gimp),
 the library file (libgmic) and the webcam gui (zart).
